import glob
from jsonc_parser.parser import JsoncParser
from pathlib import Path

LANG_FILE_PATH = Path('C:/Users/traay/AppData/Local/Packages/Microsoft.MinecraftEducationEdition_8wekyb3d8bbwe\
/LocalState/games/com.mojang/minecraftWorlds/uppakra/resource_packs/Uppraka/texts/en_US.lang')

translatable = set()

def parse_obj(obj: dict, key, ft='{}'):
    for _key, value in obj.items():
        if isinstance(value, list):
            parse_array(value, key, ft)
        elif isinstance(value, dict):
            parse_obj(value, key, ft)
        else:
            if _key == key:
                value = ft.format(value)
                translatable.add(value)

def parse_array(array: list, key, ft='{}'):
    for value in array:
        if isinstance(value, list):
            parse_array(value, key, ft)
        elif isinstance(value, dict):
            parse_obj(value, key, ft)


PARSERS = dict(
    dl=lambda data: parse_obj(data, 'translate'),
    entity=lambda data: parse_obj(data, 'identifier', 'entity.{}.name'),
    item=lambda data: parse_obj(data, 'identifier', 'item.{}.name'),
    block=lambda data: parse_obj(data, 'identifier', 'tile.{}.name'),
)
EXT = dict(
    entity='se'
)

inp = ""
supported_types = PARSERS.keys()
while inp not in supported_types:
    inp = input('Which type of files would you like to fetch missing translations for? ').strip().lower()
print()

parser = PARSERS[inp]
for fn in glob.glob(f'**/*.{EXT.get(inp, inp)}.json', recursive=True):
    data = JsoncParser.parse_file(fn)
    parser(data)

with open(LANG_FILE_PATH, 'r', encoding='utf-8') as f:
    lines = f.readlines()
for line in lines:
    if '=' in line:
        key = line.split('=', 1)[0]
        if key in translatable:
            translatable.remove(key)

print('=\n'.join(sorted(translatable)) + '=')